#! /usr/bin/env python
#

# cat mail-ticket.txt | ./ticket.py ticket@york.georgikon.hu

import string, sys, time
import re, email
import email.Header
from sqlalchemy import *

cfg = {}
""" SQL szerver beallitasai, egyezzen meg a drupal beallitasaival """
cfg['sql'] = {}
cfg['sql']['type'] = 'mysql'
cfg['sql']['server'] = 'localhost'
cfg['sql']['user'] = 'drupal'
cfg['sql']['passwd'] = 'zaqwsx'
cfg['sql']['db'] = 'drupal'
cfg['sql']['prefix'] = ''
def_charset = 'iso-8859-2'

db = create_engine(cfg['sql']['type']+'://'+cfg['sql']['user']+':'+cfg['sql']['passwd']+'@'+cfg['sql']['server']+'/'+cfg['sql']['db'], echo=False, convert_unicode=False)
conn = db.connect()


""" drupal prefix hasznalata """
def db_prefix(table):
    return cfg['sql']['prefix']+table

""" Kovetkezo ID, drupal kompatibilitas miatt """
def db_next_id(id_name):
    id_name = db_prefix(id_name)
    if ( cfg['sql']['type'] == 'mysql'):
        """ Ha MySql szervert hasznalunk """
        id_query = session.query(db_Seq)
        id = id_query.get_by(name = id_name)
        if id == None:
            id = db_Seq()
            id.name = id_name
            id.id = 1
        else:
            id.id = id.id+1

        session.save(id)
        session.flush()
        return id.id
    else:
        """ Ha PgSql szervert hasznalunk """
        if ( cfg['sql']['type'] == 'pgsql'):
            conn.execute("SELECT nextval('"+id_name+"')")
            id = conn.fetchone()[0]
            return id

""" E-Mail decodolasa """
def m2decode(msg, charset):
    global def_charset

    if charset != None:
        try:
            txt = msg.get_payload(decode=True).decode(charset)
        except:
            try:
                txt = msg.get_payload(decode=True).decode(def_charset)
            except:
                txt = msg.get_payload(decode=True).decode('utf8', 'replace')
    else:
        try:
            txt = msg.get_payload(decode=True).decode(def_charset)
        except:
	    try:
	        txt = msg.get_payload(decode=True).decode('utf8', 'replace')
            except:
	        return None

    return txt

""" Az adtatbazis strukturak es osztalyok """
seq_T = Table(cfg['sql']['prefix']+'sequences', db,
    Column('name', String(40), primary_key=True),
    Column('id', Integer)
)

class db_Seq(object):
    def __repr__(self):
        return "(name %s, id:%s)" % (self.name, self.id)

queue_T = Table(cfg['sql']['prefix']+'ticket_queue', db,
    Column('qid', Integer, primary_key=True),
    Column('uid', Integer),
    Column('gid', Integer),
    Column('encode', Integer),
    Column('priority_id', Integer),
    Column('scope_id', Integer),
    Column('site_id', Integer),
    Column('created', Integer),
    Column('summary', String(255)),
    Column('detail', TEXT)
)

class db_Queue(object):
    def __repr__(self):
        return "(qid %s, uid %s, gid %s, priority_id %s, scope_id %s, site_id %s, created %s, summary %s, detail %s)" % (self.qid, self.uid, self.gid, self.priority_id, self.scope_id, self.site_id, self.created, self.summary, self.detail)

ticket_T = Table(cfg['sql']['prefix']+'ticket_ticket', db,
    Column('tid', Integer, primary_key=True),
    Column('uid', Integer),
    Column('gid', Integer),
    Column('encode', Integer),
    Column('priority_id', Integer),
    Column('type_id', Integer),
    Column('scope_id', Integer),
    Column('site_id', Integer),
    Column('fixer_id', Integer),
    Column('assigned', Integer),
    Column('summary', String(255)),
    Column('created', Integer),
    Column('start', Integer),
    Column('detail', TEXT)
)

""" Hasznalt tablazatok konfiguralasa """
class db_Ticket(object):
    def __repr__(self):
        return "(tid %s, uid %s, gid %s, priority_id %s, type_id %s, scope_id %s, site_id %s, fixer_id %s, assigned %s, summary %s, created %s, start %s, detail %s)" % (self.tid, self.uid, self.gid, self.priority_id, self.type_id, self.scope_id, self.site_id, self.fixer_id, self.assigned, self.summary, self.created, self.start, self.detail)

mail_T = Table(cfg['sql']['prefix']+'ticket_mail', db,
    Column('mail_id', Integer, primary_key=True),
    Column('gid', Integer),
#    Column('mail_name', String(30)),
#    Column('mailto', String(30)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Mail(object):
    def __repr__(self):
        return "(mail_id %s, gid %s, default %s, active %s)" % (self.mail_id, self.gid, self.default, self.active)
#        return "(mailid %s, gid %s, mailto %s, mailfrom %s, def %s, active %s)" % (self.mailid, self.gid, self.mailto, self.mailfrom, self.default, self.active)

event_T = Table(cfg['sql']['prefix']+'ticket_event', db,
    Column('eid', Integer, primary_key=True),
    Column('tid', Integer),
    Column('uid', Integer),
    Column('reassigned', Integer),
    Column('created', Integer),
    Column('description', TEXT),
    Column('status_id', Integer)
)

class db_Event(object):
    def __repr__(self):
        return "(eid %s, tid %s, uid %s, reassigned %s, created %s, description %s, status_id %s)" % (self.eid, self.tid, self.uid, self.reassigned, self.created, self.description, self.status_id)

fixer_T = Table(cfg['sql']['prefix']+'ticket_fixer', db,
    Column('fixer_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('fixer_name', String(255)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Fixer(object):
    def __repr__(self):
        return "(fixer_id %s, gid %s, fixer_name %s, default %s, active %s)" % (self.fixer_id, self.gid, self.fixer_name, self.default, self.active)

priority_T = Table(cfg['sql']['prefix']+'ticket_priority', db,
    Column('priority_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('priority_name', String(255)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Priority(object):
    def __repr__(self):
        return "(priority_id %s, gid %s, priority_name %s, default %s, active %s)" % (self.priority_id, self.gid, self.priority_name, self.default, self.active)

rel_mail_T = Table(cfg['sql']['prefix']+'ticket_rel_ticket_mail', db,
    Column('tid', Integer, primary_key=True),
    Column('mail_id', Integer, primary_key=True),
)

class db_rel_Mail(object):
    def __repr__(self):
        return "(tid %s, mail_id %s)" % (self.tid, self.mail_id)

scope_T = Table(cfg['sql']['prefix']+'ticket_scope', db,
    Column('scope_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('scope_name', String(255)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Scope(object):
    def __repr__(self):
        return "(scope_id %s, gid %s, scope_name %s, default %s, active %s)" % (self.scope_id, self.gid, self.scope_name, self.default, self.active)

site_T = Table(cfg['sql']['prefix']+'ticket_site', db,
    Column('site_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('site_name', String(255)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Site(object):
    def __repr__(self):
        return "(site_id %s, gid %s, site_name %s, default %s, active %s)" % (self.site_id, self.gid, self.site_name, self.default, self.active)

status_T = Table(cfg['sql']['prefix']+'ticket_status', db,
    Column('status_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('status_name', String(255)),
    Column('closed', Integer),
    Column('def', Integer, key='default'),
    Column('active', Integer),
    Column('closed', Integer)
)

class db_Status(object):
    def __repr__(self):
        return "(status_id %s, gid %s, status_name %s, closed %s, default %s, active %s, closed %s)" % (self.site_id, self.gid, self.site_name, self.closed, self.default, self.active, self.closed)

type_T = Table(cfg['sql']['prefix']+'ticket_type', db,
    Column('type_id', Integer, primary_key=True),
    Column('gid', Integer),
    Column('type_name', String(255)),
    Column('def', Integer, key='default'),
    Column('active', Integer)
)

class db_Type(object):
    def __repr__(self):
        return "(type_id %s, gid %s, type_name %s, default %s, active %s)" % (self.type_id, self.gid, self.type_name, self.default, self.active)

template_T = Table(cfg['sql']['prefix']+'ticket_template', db,
    Column('gid', Integer, primary_key=True),
    Column('mailto', String(30)),
    Column('mailfrom', String(255)),
)

class db_Template(object):
    def __repr__(self):
        return "(gid %s, mailto %s, mailfrom %s)" % (self.gid , self.mailto , self.mailfrom)

""" Szukseges mapperek elkeszitese """
seqmapper = mapper(db_Seq, seq_T)
queuemapper = mapper(db_Queue, queue_T)
ticketmapper = mapper(db_Ticket, ticket_T)
mailmapper = mapper(db_Mail, mail_T)
eventmapper = mapper(db_Event, event_T)
fixermapper = mapper(db_Fixer, fixer_T)
prioritymapper = mapper(db_Priority, priority_T)
rel_mailmapper = mapper(db_rel_Mail, rel_mail_T)
scopemapper = mapper(db_Scope, scope_T)
sitemapper = mapper(db_Site, site_T)
statusmapper = mapper(db_Status, status_T)
typemapper = mapper(db_Type, type_T)
templatemapper = mapper(db_Template, template_T)

if __name__ == '__main__':
    msg = email.message_from_file(sys.stdin)
    """ Levelnek van feladoja es van parametere a scriptnek """
    if (msg.get('From') != None) and (len(sys.argv) > 1):
        """ Felado e-mail cimenek kinyerese """
        sender = email.Utils.parseaddr(msg.get('From'))

        session = create_session()
        """ A megfelelo mail template kikeresese """
        query = session.query(db_Template)
        template = query.get_by(mailto = sys.argv[1])
        if template != None:
            """ A lehetseges feladok listajanak elkeszitese """
            mailfrom = template.mailfrom
            mailfrom = mailfrom.replace(', ', ' ')
            mailfrom = mailfrom.replace(',', ' ')
            mailfrom = mailfrom.split(' ')
            """ Ha ticket 0: akkor a mail a ticket_queue tablaba kerul """
            ticket = 0
            for addr in mailfrom:
                if addr:
                    """ '.' karakter escapelese, valamint a * joker karakter regexp jokerre alakitasa """
                    addr = addr.replace('.', '\.')
                    addr = addr.replace('*', '.*')
                    """ ha van egyezes akkor a mail a ticket_ticket tablaba kerul """
                    if re.search(addr, sender[1]):
                        ticket = 1
            gid = template.gid

            """ Ticket vagy Queue tablaba kerules elokeszitese """
            if ticket:
                t_query = session.query(db_Ticket)
                db_name_id = 'ticket_ticket_tid'
                new_ticket = db_Ticket()
            else:
                t_query = session.query(db_Queue)
                db_name_id = 'ticket_queue_qid'
                new_ticket = db_Queue()
            
            """ Kovetkezo ticket vagy Queue ID """
            id = db_next_id(db_name_id)
            
            """ Default ertekekkel valo feltoltes ami azonos a Queue es a Ticket eseteben (priority, scope, site) """
            p_id_query = session.query(db_Priority)
            p_id = p_id_query.get_by(gid = gid, active = 1, default = 1)
            sc_id_query = session.query(db_Scope)
            sc_id = sc_id_query.get_by(gid = gid, active = 1, default = 1)

            si_id_query = session.query(db_Site)
            si_id = si_id_query.get_by(gid = gid, active = 1, default = 1)
            
            new_ticket.gid = gid
            new_ticket.uid = 0
            new_ticket.priority_id = p_id.priority_id
            
            if sc_id:
                new_ticket.scope_id = sc_id.scope_id
            else:
                new_ticket.scope_id = 0

            if si_id:
                new_ticket.site_id = si_id.site_id
            else:
                new_ticket.site_id = 0

            new_ticket.encode = 0

            """ UNIX timestamp keszitese e-mail feladasi datumabol """
            date = msg.get('Date')
            #created = int(time.mktime(email.Utils.parsedate(date)))-int(email.Utils.parsedate_tz(date)[9])
            #created = int(time.mktime(email.Utils.parsedate(date)))
            created = int(email.Utils.mktime_tz(email.Utils.parsedate_tz(date)))
            
            """ Szoveg atkodolasa UTF-8-ra """
            summary = unicode(email.Header.make_header(email.Header.decode_header(msg.get('subject'))))
            if summary != summary.encode('ascii', 'xmlcharrefreplace'):
                new_ticket.encode = 1
            new_ticket.summary = summary.encode('ascii', 'xmlcharrefreplace')

            detail = ''
            if msg.is_multipart():
                for part in msg.walk():
                    charset = part.get_charsets()
                    txt = m2decode(part, charset[0])
                    if txt != None:
                        if detail != '':
                            detail += "\n"
                        detail += txt
            else:
                charset = msg.get_charsets()
                txt = m2decode(msg, charset[0])
                if txt != None:
                    detail += txt

            if detail != detail.encode('ascii', 'xmlcharrefreplace'):
                new_ticket.encode = 1

            new_ticket.detail = detail.encode('ascii', 'xmlcharrefreplace')
	    """ Ticket vagy Queue hozza adasa """
            if ticket:
                """ Tickethez szukseges ertekek feltoltese (assigned, type, fixer) """
                new_ticket.tid = id
                new_ticket.assigned = 0

                tt_id_query = session.query(db_Type)
                tt_id = tt_id_query.get_by(gid = gid, active = 1, default = 1)
                new_ticket.type_id = tt_id.type_id

                f_id_query = session.query(db_Fixer)
                f_id = f_id_query.get_by(gid = gid, active = 1, default = 1)
                if f_id:
                    new_ticket.fixer_id = f_id.fixer_id
                else:
                    new_ticket.fixer_id = 0

                """ Aktualis datum lekerdezese """
                now = int(time.mktime(time.localtime()))
                new_ticket.created = now
                new_ticket.start = created

                """ Ures event letrehozasa """
                eid = db_next_id('ticket_event_eid')
                new_event = db_Event()
                new_event.eid = eid
                new_event.tid = id
                new_event.uid = 0
                new_event.reassigned = 0
                new_event.created = now
                new_event.description = ''

                """ Eventhez szukseges alapertelmezett status lekerdezese """
                status_id_query = session.query(db_Status)
                status_id = status_id_query.get_by(gid = gid, active = 1, default = 1, closed = 0)
                new_event.status_id = status_id.status_id

                """ Ticket - mail osszekapcsolasa """
                m_id_query = session.query(db_Mail)
                m_id = m_id_query.select_by(gid = gid, active = 1, default = 1)
                if m_id:
                    for mid in m_id:
                        new_rel_mail = db_rel_Mail()
                        new_rel_mail.tid = id
                        new_rel_mail.mail_id = mid.mail_id
                        session.save(new_rel_mail)
            else:
                """ Queue-hoz szukseges egyedi tulajdonsagok beallitasa """
                new_ticket.qid = id
                new_ticket.created = created

            """ Ticket/Queue elmentese, SQL utasitasok vegrehajtasa """
            session.save(new_ticket)
            if ticket:
                """ event elmentese """
                session.save(new_event)

            OK = False
    	    while not OK:
                #session.flush()
                try:
                    session.flush()
                    OK = True
                except exceptions.SQLError, err: 
                    #print dir(err)
                    #print err.statement
                    if err.orig[1].find('Duplicate') >= 0 :
                        session.clear()

                        if err.statement.find('ticket_queue') >= 0 :
                            id = db_next_id(db_name_id)
                            new_ticket.qid = id
                            session.save(new_ticket)
                        elif err.statement.find('ticket_ticket') >= 0 :
                            id = db_next_id(db_name_id)
                            new_event.tid = id
                            new_ticket.tid = id
                            session.save(new_ticket)
                            session.save(new_event)
                        elif err.statement.find('ticket_event') >= 0 :
                            eid = db_next_id('ticket_event_eid')
                            new_event.eid = eid
                            session.save(new_event)
                    else:
                        raise err
                        OK = True

            """ Session lezarasa """
            session.close()

#print dir(mail)
""" Kapcsolat lezarasa """
conn.close()
